//******************************************************************************
#ifndef ___RenamerApp___
#define ___RenamerApp___
//******************************************************************************
#include <wx/app.h>
#include <vector>
class wxFrame;
class wxTextCtrl;
class wxButton;
class wxCommandEvent;
class wxTextFile;
class wxDir;
//******************************************************************************
namespace MP3Renamer
{
	class Log;

	enum RenamerFrameIDs
	{
		RootFolder,
		Mask,
		OK,
		Cancel,
		Help,
		Folder
	};

	struct MP3RFolder
	{
		wxDir * m_folder;
		wxString m_name;
		unsigned int m_nbMP3s;
		std::vector <MP3RFolder *> m_childs;
		std::vector <wxString> m_files;
		
		MP3RFolder( const wxString & p_name = wxEmptyString);
		~MP3RFolder();
		void ChangeFiles();
	};

	//******************************************************************************
	class RenamerApp : public wxApp
	{
	private:
		wxFrame * m_mainFrame;
		wxFrame * m_helpFrame;
		wxTextCtrl * m_rootFolder;
		wxTextCtrl * m_mask;
		wxButton * m_ok;
		wxButton * m_cancel;
		wxButton * m_help;
		wxButton * m_folderButton;

		wxString m_path;
		wxString m_maskTxt;

		std::vector <wxString> m_filesToChange;
		MP3RFolder * m_tree;

		Log * m_log;

	public:
		virtual bool OnInit();
		wxString ExtractFileExt( const wxString & p_name);

	private:
		void _onHelp			( wxCommandEvent & p_event);
		void _onOK				( wxCommandEvent & p_event);
		void _onCancel			( wxCommandEvent & p_event);
		void _onFolderButton	( wxCommandEvent & p_event);
		void _onFolderChange	( wxCommandEvent & p_event);
		void _onMaskChange		( wxCommandEvent & p_event);

		void _buildHelpText();
		void _processChange();
		void _listFilesToChange();
		void _findFiles( MP3RFolder * p_folder);

		void _changeFiles();

		DECLARE_EVENT_TABLE()
	};
}
//******************************************************************************
#endif
//******************************************************************************