//******************************************************************************
#ifndef ___RenamerThread___
#define ___RenamerThread___
//******************************************************************************
#include <wx/thread.h>
//******************************************************************************
namespace MP3Renamer
{
	struct MP3Infos
	{
		wxString m_title;
		wxString m_track;
		wxString m_album;
		wxString m_year;
		wxString m_artist;
		wxString m_gender;

		void Init()
		{
			m_title.clear();
			m_track.clear();
			m_album.clear();
			m_year.clear();
			m_artist.clear();
			m_gender.clear();
		}
	};

	class RenamerThread : public wxThread
	{
	private:
		wxString m_path;
		wxString m_filePath;
		wxString m_maskTxt;

	public:
		RenamerThread( const wxString & p_path, const wxString & p_file, const wxString & p_mask);
		virtual void * Entry();

	private:
		void _normalise( wxString & p_str);
		void _retrieveInfos( MP3Infos & p_infos, const wxString & m_fileName);
		bool _generatePath( wxString & p_generatedPath, const MP3Infos & p_infos);
		void _generateFolders( const wxString & p_path);
		void _replaceFile( const wxString & p_oldPath, const wxString & p_newPath);
	};
}
//******************************************************************************
#endif
//******************************************************************************